From cd0793f0f1b461435ea04e2ae83fed1e03388d64 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 26 2020 01:12:15 +0000
Subject: [PATCH 200/2232] Merge pull request #84 from dtolnay/check


Typecheck refactor
---

diff --git a/syntax/check.rs b/syntax/check.rs
index 742ecc2..256a193 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,139 +1,167 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{error, ident, Api, ExternFn, Ref, Struct, Ty1, Type, Types, Var};
+use crate::syntax::{error, ident, Api, ExternFn, Ref, Struct, Ty1, Type, Types};
 use proc_macro2::{Delimiter, Group, Ident, TokenStream};
-use quote::quote;
+use quote::{quote, ToTokens};
+use std::fmt::Display;
 use syn::{Error, Result};
 
+struct Check<'a> {
+    apis: &'a [Api],
+    types: &'a Types<'a>,
+    errors: &'a mut Vec<Error>,
+}
+
 pub(crate) fn typecheck(apis: &[Api], types: &Types) -> Result<()> {
     let mut errors = Vec::new();
+    let mut cx = Check {
+        apis,
+        types,
+        errors: &mut errors,
+    };
+    do_typecheck(&mut cx);
+    combine_errors(errors)
+}
 
-    for ty in types {
+fn do_typecheck(cx: &mut Check) {
+    for ty in cx.types {
         match ty {
-            Type::Ident(ident) => {
-                if Atom::from(ident).is_none()
-                    && !types.structs.contains_key(ident)
-                    && !types.cxx.contains(ident)
-                    && !types.rust.contains(ident)
-                {
-                    errors.push(unsupported_type(ident));
-                }
-            }
-            Type::RustBox(ptr) => {
-                if let Type::Ident(ident) = &ptr.inner {
-                    if types.cxx.contains(ident) {
-                        errors.push(unsupported_cxx_type_in_box(ptr));
-                    }
-                    if Atom::from(ident).is_none() {
-                        continue;
-                    }
-                }
-                errors.push(unsupported_box_target(ptr));
-            }
-            Type::UniquePtr(ptr) => {
-                if let Type::Ident(ident) = &ptr.inner {
-                    if types.rust.contains(ident) {
-                        errors.push(unsupported_rust_type_in_unique_ptr(ptr));
-                    }
-                    match Atom::from(ident) {
-                        None | Some(CxxString) => continue,
-                        _ => {}
-                    }
-                }
-                errors.push(unsupported_unique_ptr_target(ptr));
-            }
-            Type::Ref(ty) => {
-                if let Type::Void(_) = ty.inner {
-                    errors.push(unsupported_reference_type(ty));
-                }
-            }
-            Type::Fn(_) => errors.push(unimplemented_fn_type(ty)),
+            Type::Ident(ident) => check_type_ident(cx, ident),
+            Type::RustBox(ptr) => check_type_box(cx, ptr),
+            Type::UniquePtr(ptr) => check_type_unique_ptr(cx, ptr),
+            Type::Ref(ty) => check_type_ref(cx, ty),
+            Type::Fn(_) => cx.error(ty, "function pointer support is not implemented yet"),
             _ => {}
         }
     }
 
-    for api in apis {
+    for api in cx.apis {
         match api {
-            Api::Struct(strct) => {
-                if strct.fields.is_empty() {
-                    errors.push(struct_empty(strct));
-                }
-                for field in &strct.fields {
-                    if is_unsized(&field.ty, types) {
-                        errors.push(field_by_value(field, types));
-                    }
-                }
-            }
-            Api::CxxFunction(efn) | Api::RustFunction(efn) => {
-                for arg in &efn.args {
-                    if is_unsized(&arg.ty, types) {
-                        errors.push(argument_by_value(arg, types));
-                    }
-                }
-                if let Some(ty) = &efn.ret {
-                    if is_unsized(ty, types) {
-                        errors.push(return_by_value(ty, types));
-                    }
-                }
-            }
+            Api::Struct(strct) => check_api_struct(cx, strct),
+            Api::CxxFunction(efn) | Api::RustFunction(efn) => check_api_fn(cx, efn),
             _ => {}
         }
     }
 
-    for api in apis {
+    for api in cx.apis {
         if let Api::CxxFunction(efn) = api {
-            errors.extend(check_mut_return_restriction(efn).err());
+            check_mut_return_restriction(cx, efn);
         }
         if let Api::CxxFunction(efn) | Api::RustFunction(efn) = api {
-            errors.extend(check_multiple_arg_lifetimes(efn).err());
+            check_multiple_arg_lifetimes(cx, efn);
         }
     }
 
-    ident::check_all(apis, &mut errors);
+    ident::check_all(cx.apis, cx.errors);
+}
 
-    let mut iter = errors.into_iter();
-    let mut all_errors = match iter.next() {
-        Some(err) => err,
-        None => return Ok(()),
-    };
-    for err in iter {
-        all_errors.combine(err);
+impl Check<'_> {
+    fn error(&mut self, sp: impl ToTokens, msg: impl Display) {
+        self.errors.push(Error::new_spanned(sp, msg));
     }
-    Err(all_errors)
 }
 
-fn is_unsized(ty: &Type, types: &Types) -> bool {
-    let ident = match ty {
-        Type::Ident(ident) => ident,
-        Type::Void(_) => return true,
-        _ => return false,
-    };
-    ident == CxxString || types.cxx.contains(ident) || types.rust.contains(ident)
+fn check_type_ident(cx: &mut Check, ident: &Ident) {
+    if Atom::from(ident).is_none()
+        && !cx.types.structs.contains_key(ident)
+        && !cx.types.cxx.contains(ident)
+        && !cx.types.rust.contains(ident)
+    {
+        cx.error(ident, "unsupported type");
+    }
 }
 
-fn check_mut_return_restriction(efn: &ExternFn) -> Result<()> {
+fn check_type_box(cx: &mut Check, ptr: &Ty1) {
+    if let Type::Ident(ident) = &ptr.inner {
+        if cx.types.cxx.contains(ident) {
+            cx.error(ptr, error::BOX_CXX_TYPE.msg);
+        }
+
+        if Atom::from(ident).is_none() {
+            return;
+        }
+    }
+
+    cx.error(ptr, "unsupported target type of Box");
+}
+
+fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
+    if let Type::Ident(ident) = &ptr.inner {
+        if cx.types.rust.contains(ident) {
+            cx.error(ptr, "unique_ptr of a Rust type is not supported yet");
+        }
+
+        match Atom::from(ident) {
+            None | Some(CxxString) => return,
+            _ => {}
+        }
+    }
+
+    cx.error(ptr, "unsupported unique_ptr target type");
+}
+
+fn check_type_ref(cx: &mut Check, ty: &Ref) {
+    if let Type::Void(_) = ty.inner {
+        cx.error(ty, "unsupported reference type");
+    }
+}
+
+fn check_api_struct(cx: &mut Check, strct: &Struct) {
+    if strct.fields.is_empty() {
+        let span = span_for_struct_error(strct);
+        cx.error(span, "structs without any fields are not supported");
+    }
+
+    for field in &strct.fields {
+        if is_unsized(cx, &field.ty) {
+            let desc = describe(cx, &field.ty);
+            let msg = format!("using {} by value is not supported", desc);
+            cx.error(field, msg);
+        }
+    }
+}
+
+fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
+    for arg in &efn.args {
+        if is_unsized(cx, &arg.ty) {
+            let desc = describe(cx, &arg.ty);
+            let msg = format!("passing {} by value is not supported", desc);
+            cx.error(arg, msg);
+        }
+    }
+
+    if let Some(ty) = &efn.ret {
+        if is_unsized(cx, ty) {
+            let desc = describe(cx, ty);
+            let msg = format!("returning {} by value is not supported", desc);
+            cx.error(ty, msg);
+        }
+    }
+}
+
+fn check_mut_return_restriction(cx: &mut Check, efn: &ExternFn) {
     match &efn.ret {
         Some(Type::Ref(ty)) if ty.mutability.is_some() => {}
-        _ => return Ok(()),
+        _ => return,
     }
 
     for arg in &efn.args {
         if let Type::Ref(ty) = &arg.ty {
             if ty.mutability.is_some() {
-                return Ok(());
+                return;
             }
         }
     }
 
-    Err(Error::new_spanned(
+    cx.error(
         efn,
         "&mut return type is not allowed unless there is a &mut argument",
-    ))
+    );
 }
 
-fn check_multiple_arg_lifetimes(efn: &ExternFn) -> Result<()> {
+fn check_multiple_arg_lifetimes(cx: &mut Check, efn: &ExternFn) {
     match &efn.ret {
         Some(Type::Ref(_)) => {}
-        _ => return Ok(()),
+        _ => return,
     }
 
     let mut reference_args = 0;
@@ -143,24 +171,50 @@ fn check_multiple_arg_lifetimes(efn: &ExternFn) -> Result<()> {
         }
     }
 
-    if reference_args == 1 {
-        Ok(())
-    } else {
-        Err(Error::new_spanned(
+    if reference_args != 1 {
+        cx.error(
             efn,
             "functions that return a reference must take exactly one input reference",
-        ))
+        );
+    }
+}
+
+fn is_unsized(cx: &mut Check, ty: &Type) -> bool {
+    let ident = match ty {
+        Type::Ident(ident) => ident,
+        Type::Void(_) => return true,
+        _ => return false,
+    };
+    ident == CxxString || cx.types.cxx.contains(ident) || cx.types.rust.contains(ident)
+}
+
+fn span_for_struct_error(strct: &Struct) -> TokenStream {
+    let struct_token = strct.struct_token;
+    let mut brace_token = Group::new(Delimiter::Brace, TokenStream::new());
+    brace_token.set_span(strct.brace_token.span);
+    quote!(#struct_token #brace_token)
+}
+
+fn combine_errors(errors: Vec<Error>) -> Result<()> {
+    let mut iter = errors.into_iter();
+    let mut all_errors = match iter.next() {
+        Some(err) => err,
+        None => return Ok(()),
+    };
+    for err in iter {
+        all_errors.combine(err);
     }
+    Err(all_errors)
 }
 
-fn describe(ty: &Type, types: &Types) -> String {
+fn describe(cx: &mut Check, ty: &Type) -> String {
     match ty {
         Type::Ident(ident) => {
-            if types.structs.contains_key(ident) {
+            if cx.types.structs.contains_key(ident) {
                 "struct".to_owned()
-            } else if types.cxx.contains(ident) {
+            } else if cx.types.cxx.contains(ident) {
                 "C++ type".to_owned()
-            } else if types.rust.contains(ident) {
+            } else if cx.types.rust.contains(ident) {
                 "opaque Rust type".to_owned()
             } else if Atom::from(ident) == Some(CxxString) {
                 "C++ string".to_owned()
@@ -176,57 +230,3 @@ fn describe(ty: &Type, types: &Types) -> String {
         Type::Void(_) => "()".to_owned(),
     }
 }
-
-fn unsupported_type(ident: &Ident) -> Error {
-    Error::new(ident.span(), "unsupported type")
-}
-
-fn unsupported_reference_type(ty: &Ref) -> Error {
-    Error::new_spanned(ty, "unsupported reference type")
-}
-
-fn unsupported_cxx_type_in_box(unique_ptr: &Ty1) -> Error {
-    Error::new_spanned(unique_ptr, error::BOX_CXX_TYPE.msg)
-}
-
-fn unsupported_box_target(unique_ptr: &Ty1) -> Error {
-    Error::new_spanned(unique_ptr, "unsupported target type of Box")
-}
-
-fn unsupported_rust_type_in_unique_ptr(unique_ptr: &Ty1) -> Error {
-    Error::new_spanned(unique_ptr, "unique_ptr of a Rust type is not supported yet")
-}
-
-fn unsupported_unique_ptr_target(unique_ptr: &Ty1) -> Error {
-    Error::new_spanned(unique_ptr, "unsupported unique_ptr target type")
-}
-
-fn struct_empty(strct: &Struct) -> Error {
-    let struct_token = strct.struct_token;
-    let mut brace_token = Group::new(Delimiter::Brace, TokenStream::new());
-    brace_token.set_span(strct.brace_token.span);
-    let span = quote!(#struct_token #brace_token);
-    Error::new_spanned(span, "structs without any fields are not supported")
-}
-
-fn field_by_value(field: &Var, types: &Types) -> Error {
-    let desc = describe(&field.ty, types);
-    let message = format!("using {} by value is not supported", desc);
-    Error::new_spanned(field, message)
-}
-
-fn argument_by_value(arg: &Var, types: &Types) -> Error {
-    let desc = describe(&arg.ty, types);
-    let message = format!("passing {} by value is not supported", desc);
-    Error::new_spanned(arg, message)
-}
-
-fn return_by_value(ty: &Type, types: &Types) -> Error {
-    let desc = describe(ty, types);
-    let message = format!("returning {} by value is not supported", desc);
-    Error::new_spanned(ty, message)
-}
-
-fn unimplemented_fn_type(ty: &Type) -> Error {
-    Error::new_spanned(ty, "function pointer support is not implemented yet")
-}

